Index: trunk/packages/sipb-xen-www/debian/changelog
===================================================================
--- trunk/packages/sipb-xen-www/debian/changelog	(revision 507)
+++ trunk/packages/sipb-xen-www/debian/changelog	(revision 509)
@@ -1,2 +1,8 @@
+sipb-xen-www (3.2) unstable; urgency=low
+
+  * Check in (part of?) the Apache config.
+
+ -- Greg Price <price@mit.edu>  Fri,  9 May 2008 00:03:08 -0400
+
 sipb-xen-www (3.1) unstable; urgency=low
 
Index: trunk/packages/sipb-xen-www/files/etc/apache2/conf.d/sipb-xen-repository
===================================================================
--- trunk/packages/sipb-xen-www/files/etc/apache2/conf.d/sipb-xen-repository	(revision 509)
+++ trunk/packages/sipb-xen-www/files/etc/apache2/conf.d/sipb-xen-repository	(revision 509)
@@ -0,0 +1,17 @@
+Alias /sipb-xen /srv/repository
+
+Alias /debian/ /debian/
+
+<Directory /srv/repository>
+		Options Indexes FollowSymLinks MultiViews
+		AllowOverride None
+		Order allow,deny
+		allow from all
+</Directory>
+
+<Directory /debian>
+		Options Indexes FollowSymLinks MultiViews
+		AllowOverride None
+		Order allow,deny
+		allow from all
+</Directory>
Index: trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/default
===================================================================
--- trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/default	(revision 509)
+++ trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/default	(revision 509)
@@ -0,0 +1,54 @@
+NameVirtualHost *:80
+<VirtualHost *:80>
+	ServerAdmin webmaster@localhost
+	
+	DocumentRoot /var/www/
+	<Directory /var/www/>
+		Options Indexes FollowSymLinks MultiViews ExecCGI
+		AllowOverride None
+		Order allow,deny
+		allow from all
+		# This directive allows us to have apache2's default start page
+                # in /apache2-default/, but still have / go to the right place
+                #RedirectMatch ^/$ /apache2-default/
+		#Redirect / https://sipb-xen-dev.mit.edu/
+		#RedirectMatch ^/(!?trac) https://sipb-xen-dev.mit.edu/
+	</Directory>
+
+	RewriteEngine On
+	#RewriteRule ^/trac - [L]
+        RewriteRule ^/trac.fcgi(.*) - [L]
+        RewriteRule ^/trac/chrome/common(.*) /usr/share/trac/htdocs$1 [L]
+	RewriteRule ^/trac/login(.*) https://sipb-xen-dev.mit.edu/trac/login$1 [L]
+        RewriteRule ^/trac(.*) /var/www/trac/trac.fcgi$1 [L]
+	RewriteRule ^/sipb-xen - [L]
+	RewriteRule ^(.*) https://sipb-xen-dev.mit.edu$1
+
+	ScriptAlias /cgi-bin/ /usr/lib/cgi-bin/
+	<Directory "/usr/lib/cgi-bin">
+		AllowOverride None
+		Options ExecCGI -MultiViews +SymLinksIfOwnerMatch
+		Order allow,deny
+		Allow from all
+		#Redirect / https://sipb-xen-dev.mit.edu/
+	</Directory>
+
+	ErrorLog /var/log/apache2/error.log
+
+	# Possible values include: debug, info, notice, warn, error, crit,
+	# alert, emerg.
+	LogLevel notice
+
+	CustomLog /var/log/apache2/access.log combined
+	ServerSignature On
+
+    Alias /doc/ "/usr/share/doc/"
+    <Directory "/usr/share/doc/">
+        Options Indexes MultiViews FollowSymLinks
+        AllowOverride None
+        Order deny,allow
+        Deny from all
+        Allow from 127.0.0.0/255.0.0.0 ::1/128
+    </Directory>
+
+</VirtualHost>
Index: trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/ssl
===================================================================
--- trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/ssl	(revision 509)
+++ trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/ssl	(revision 509)
@@ -0,0 +1,88 @@
+<VirtualHost *:443>
+	ServerAdmin sipb-xen@mit.edu
+	ServerName sipb-xen-dev.mit.edu:443
+	
+	DocumentRoot /var/www/sipb-xen-www
+	<Directory /var/www/sipb-xen-www>
+		Options Indexes FollowSymLinks MultiViews ExecCGI
+		AllowOverride None
+		Order allow,deny
+		allow from all
+	</Directory>
+	<Location />
+		Require valid-user
+		AuthType SSLCert
+		AuthSSLCertVar SSL_CLIENT_S_DN_Email
+		AuthSSLCertStripSuffix "@MIT.EDU"
+	</Location>
+
+	RewriteEngine On
+	RewriteRule ^/static(.*) - [L]
+	RewriteRule ^/trac.fcgi(.*) - [L]
+	RewriteRule ^/trac/chrome/common(.*) /usr/share/trac/htdocs$1 [L]
+	RewriteRule ^/trac(.*) /var/www/trac/trac.fcgi$1 [L]
+	RewriteRule ^/var(.*) - [L]
+	RewriteRule ^/wiki(.*) - [L]
+	RewriteRule ^/(.*) /var/www/sipb-xen-www/main.py/$1 [L]
+
+	RewriteLog /var/log/apache2/rewrite.log
+	RewriteLogLevel 0 
+
+	ErrorLog /var/log/apache2/error.log
+
+	# Possible values include: debug, info, notice, warn, error, crit,
+	# alert, emerg.
+	LogLevel warn
+
+	CustomLog /var/log/apache2/ssl_access.log combined
+	ServerSignature On
+
+	SSLEngine on
+
+	SSLCertificateFile ssl/server.crt
+	SSLCertificateKeyFile ssl/server.key
+	
+	SSLCACertificateFile ssl/mitCAclient.pem
+	SSLVerifyClient optional
+	SSLVerifyDepth 10
+
+	SSLOptions +StdEnvVars
+	
+	SetEnvIf User-Agent ".*MSIE.*" nokeepalive ssl-unclean-shutdown downgrade-1.0 force-response-1.0
+
+
+	Redirect /wiki https://sipb-xen-dev.mit.edu/trac/wiki	
+</VirtualHost>
+
+<VirtualHost *:446>
+	ServerAdmin sipb-xen@mit.edu
+	ServerName sipb-xen-dev.mit.edu:446
+	
+	DocumentRoot /var/www/sipb-xen-www
+	<Directory />
+		Options Indexes FollowSymLinks MultiViews ExecCGI
+		AllowOverride None
+		Order allow,deny
+		allow from all
+	</Directory>
+
+	ErrorLog /var/log/apache2/error.log
+
+	# Possible values include: debug, info, notice, warn, error, crit,
+	# alert, emerg.
+	LogLevel warn
+
+	CustomLog /var/log/apache2/ssl_nocert_access.log combined
+	ServerSignature On
+
+	SSLEngine on
+
+	SSLCertificateFile ssl/server.crt
+	SSLCertificateKeyFile ssl/server.key
+	
+	SSLVerifyClient none
+
+	SSLOptions +StdEnvVars
+	
+	SetEnvIf User-Agent ".*MSIE.*" nokeepalive ssl-unclean-shutdown downgrade-1.0 force-response-1.0	
+</VirtualHost>
Index: trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/svn
===================================================================
--- trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/svn	(revision 509)
+++ trunk/packages/sipb-xen-www/files/etc/apache2/sites-available/svn	(revision 509)
@@ -0,0 +1,35 @@
+<VirtualHost *:1111>
+	ServerAdmin sipb-xen@mit.edu
+	ServerName sipb-xen-dev.mit.edu:1111
+	
+	<Directory />
+		Options FollowSymLinks
+		AllowOverride None
+	</Directory>
+	<Location />
+		DAV svn
+		SVNPath /afs/sipb.mit.edu/project/xen/svn
+		AuthType Basic
+		AuthName "sipb-xen.mit.edu subversion repository"
+		AuthUserFile /etc/apache2/dav_svn.passwd
+		<LimitExcept GET PROPFIND OPTIONS REPORT>
+			Require valid-user
+		</LimitExcept>
+	</Location>
+
+	ErrorLog /var/log/apache2/error.log
+
+	# Possible values include: debug, info, notice, warn, error, crit,
+	# alert, emerg.
+	LogLevel warn
+
+	CustomLog /var/log/apache2/ssl_access.log combined
+	ServerSignature On
+
+	SSLEngine on
+
+	SSLCertificateFile ssl/server.crt
+	SSLCertificateKeyFile ssl/server.key
+	
+	SetEnvIf User-Agent ".*MSIE.*" nokeepalive ssl-unclean-shutdown downgrade-1.0 force-response-1.0
+</VirtualHost>
Index: trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/000-default
===================================================================
--- trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/000-default	(revision 509)
+++ trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/000-default	(revision 509)
@@ -0,0 +1,1 @@
+link ../sites-available/default
Index: trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/ssl
===================================================================
--- trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/ssl	(revision 509)
+++ trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/ssl	(revision 509)
@@ -0,0 +1,1 @@
+link ../sites-available/ssl
Index: trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/svn
===================================================================
--- trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/svn	(revision 509)
+++ trunk/packages/sipb-xen-www/files/etc/apache2/sites-enabled/svn	(revision 509)
@@ -0,0 +1,1 @@
+link ../sites-available/svn