Index: trunk/packages/sipb-xen-www/code/validation.py
===================================================================
--- trunk/packages/sipb-xen-www/code/validation.py	(revision 537)
+++ trunk/packages/sipb-xen-www/code/validation.py	(revision 572)
@@ -6,5 +6,5 @@
 import string
 from sipb_xen_database import Machine, NIC, Type, Disk
-from webcommon import InvalidInput, g
+from webcommon import InvalidInput
 
 MAX_MEMORY_TOTAL = 512
@@ -17,5 +17,47 @@
 MAX_VMS_ACTIVE = 4
 
-def getMachinesByOwner(user, machine=None):
+class Validate:
+    def __init__(self, username, state, machine_id=None, name=None, owner=None,
+                 admin=None, contact=None, memory=None, disksize=None,
+                 vmtype=None, cdrom=None, clone_from=None):
+        # XXX Successive quota checks aren't a good idea, since you
+        # can't necessarily change the locker and disk size at the
+        # same time.
+        created_new = (machine_id is None)
+
+        if machine_id is not None:
+            self.machine = testMachineId(username, machine_id)
+        machine = getattr(self, 'machine', None)
+
+        owner = testOwner(username, owner, machine)
+        if owner is not None:
+            self.owner = owner
+        admin = testAdmin(username, admin, machine)
+        if admin is not None:
+            self.admin = admin
+        contact = testContact(username, contact, machine)
+        if contact is not None:
+            self.contact = contact
+        name = testName(username, name, machine)
+        if name is not None:
+            self.name = name
+        if memory is not None:
+            self.memory = validMemory(self.owner, state, memory, machine,
+                                      on=not created_new)
+        if disksize is not None:
+            self.disksize = validDisk(self.owner, disksize, machine)
+        if vmtype is not None:
+            self.vmtype = validVmType(vmtype)
+        if cdrom is not None:
+            if not CDROM.get(cdrom):
+                raise CodeError("Invalid cdrom type '%s'" % cdrom)
+            self.cdrom = cdrom
+        if clone_from is not None:
+            if clone_from not in ('ice3', ):
+                raise CodeError("Invalid clone image '%s'" % clone_from)
+            self.clone_from = clone_from
+
+
+def getMachinesByOwner(owner, machine=None):
     """Return the machines owned by the same as a machine.
 
@@ -25,9 +67,7 @@
     if machine:
         owner = machine.owner
-    else:
-        owner = user
     return Machine.select_by(owner=owner)
 
-def maxMemory(user, machine=None, on=True):
+def maxMemory(owner, g, machine=None, on=True):
     """Return the maximum memory for a machine or a user.
 
@@ -44,10 +84,10 @@
     if not on:
         return MAX_MEMORY_SINGLE
-    machines = getMachinesByOwner(user, machine)
+    machines = getMachinesByOwner(owner, machine)
     active_machines = [x for x in machines if g.xmlist.get(x)]
     mem_usage = sum([x.memory for x in active_machines if x != machine])
     return min(MAX_MEMORY_SINGLE, MAX_MEMORY_TOTAL-mem_usage)
 
-def maxDisk(user, machine=None):
+def maxDisk(owner, machine=None):
     """Return the maximum disk that a machine can reach.
 
@@ -60,9 +100,9 @@
         machine_id = None
     disk_usage = Disk.query().filter_by(Disk.c.machine_id != machine_id,
-                                        owner=user).sum(Disk.c.size) or 0
+                                        owner=owner).sum(Disk.c.size) or 0
     return min(MAX_DISK_SINGLE, MAX_DISK_TOTAL-disk_usage/1024.)
 
-def cantAddVm(user):
-    machines = getMachinesByOwner(user)
+def cantAddVm(owner, g):
+    machines = getMachinesByOwner(owner)
     active_machines = [x for x in machines if g.xmlist.get(x)]
     if len(machines) >= MAX_VMS_TOTAL:
@@ -72,10 +112,4 @@
                 'To create more, turn one off.')
     return False
-
-def validAddVm(user):
-    reason = cantAddVm(user)
-    if reason:
-        raise InvalidInput('create', True, reason)
-    return True
 
 def haveAccess(user, machine):
@@ -99,6 +133,6 @@
     return True
 
-def validMemory(user, memory, machine=None, on=True):
-    """Parse and validate limits for memory for a given user and machine.
+def validMemory(owner, g, memory, machine=None, on=True):
+    """Parse and validate limits for memory for a given owner and machine.
 
     on is whether the memory must be valid after the machine is
@@ -112,17 +146,17 @@
         raise InvalidInput('memory', memory,
                            "Minimum %s MiB" % MIN_MEMORY_SINGLE)
-    if memory > maxMemory(user, machine, on):
+    max_val = maxMemory(owner, g, machine, on)
+    if memory > max_val:
         raise InvalidInput('memory', memory,
-                           'Maximum %s MiB for %s' % (maxMemory(user, machine),
-                                                      user))
+                           'Maximum %s MiB for %s' % (max_val, owner))
     return memory
 
-def validDisk(user, disk, machine=None):
-    """Parse and validate limits for disk for a given user and machine."""
+def validDisk(owner, disk, machine=None):
+    """Parse and validate limits for disk for a given owner and machine."""
     try:
         disk = float(disk)
-        if disk > maxDisk(user, machine):
+        if disk > maxDisk(owner, machine):
             raise InvalidInput('disk', disk,
-                               "Maximum %s G" % maxDisk(user, machine))
+                               "Maximum %s G" % maxDisk(owner, machine))
         disk = int(disk * 1024)
         if disk < MIN_DISK_SINGLE * 1024:
@@ -191,6 +225,8 @@
     If machine is None, this is the owner of a new machine.
     """
-    if owner == user or machine is not None and owner == machine.owner:
+    if owner == user:
         return owner
+    if machine is not None and owner in (machine.owner, None):
+        return None
     if owner is None:
         raise InvalidInput('owner', owner, "Owner must be specified")
@@ -214,7 +250,11 @@
 
 def testName(user, name, machine=None):
-    if name in (None, machine.name):
+    if name is None:
+        return None
+    if machine is not None and name == machine.name:
         return None
     if not Machine.select_by(name=name):
+        if not validMachineName(name):
+            raise InvalidInput('name', name, 'You must provide a machine name.  Max 22 chars, alnum plus \'-\' and \'_\'.')
         return name
     raise InvalidInput('name', name, "Name is already taken.")