Index: trunk/packages/sipb-xen-www/code/main.py
===================================================================
--- trunk/packages/sipb-xen-www/code/main.py	(revision 886)
+++ trunk/packages/sipb-xen-www/code/main.py	(revision 912)
@@ -470,4 +470,8 @@
 your machine will run just fine, but the applet's display of the
 console will suffer artifacts.
+""",
+                    'Windows': """
+<strong>Windows Vista:</strong> The Vista image is licensed for all MIT students and will automatically activate off the network; see <a href="/static/msca-email.txt">the licensing confirmation e-mail</a> for details. The installer req	uires 512 MB RAM and at least 7.5 GB disk space (15 GB or more recommended).<br>
+<strong>Windows XP:</strong> This is the volume license CD image. You will need your own volume license key to complete the install. We do not have these available for the general MIT community; ask your department if they have one.
 """
                     }
Index: trunk/packages/sipb-xen-www/code/static/msca-email.txt
===================================================================
--- trunk/packages/sipb-xen-www/code/static/msca-email.txt	(revision 912)
+++ trunk/packages/sipb-xen-www/code/static/msca-email.txt	(revision 912)
@@ -0,0 +1,65 @@
+From: MIT MS Campus Agreement <ms-campus-agreement@MIT.EDU>
+Subject: Windows Vista upgrade - student download
+
+Greetings,
+
+Thank-you for visiting Information Services and Technology's (IS&T) download 
+site for Windows Vista Enterprise.  This software upgrade service is 
+provided via MIT's Microsoft Campus Agreement (MSCA).
+
+MIT has signed a three year Campus Agreement with Microsoft effective 
+through June 2007 which allows IS&T to provide Windows Vista Enterprise 
+software upgrades at no cost to MIT undergraduate and graduate students. 
+MIT students are entitled to install this software on one personally owned 
+machine to be used for educational purposes.  Graduating students retain the 
+continued right to run the last version of the software received while at 
+MIT by completing the Campus Agreement Student License Confirmation.  This 
+agreement will be e-mailed to you during your last semester at MIT.
+
+Undergraduate or graduate students who withdraw, transfer, or otherwise 
+leave MIT prior to graduation do not have the continued right to use this 
+software and should delete it from your machines.
+
+Your right to use the software shall be governed by the most current license 
+rights, which you may view at
+
+     <http://www.microsoft.com/education/license/terms.asp>.
+
+The following website includes helpful information about Windows Vista 
+Enterprise and topics to consider prior to upgrading one's machine
+
+     <http://itinfo.mit.edu/product.php?vid=735>
+
+Windows Vista Enterprise does not require a product key to install or use 
+the software.  Instead, Activation is used instead of a product key.  If 
+properly configured, your machine will automatically activate when on the 
+MIT Network.  If you have troubles activating your system or are using on a 
+machine that is not on the MIT Network, such as a home machine, see the 
+Activation instructions at
+
+        <http://itinfo.mit.edu/article.php?id=8299>
+
+IS&T wishes to remind colleagues and students of the importance of keeping 
+one's computer current with operating system patches.  IS&T recommends the 
+use of vendor's automatic update services in tandem of our local 
+implementations of...
+
+     MIT Windows Automatic Update Service (WAUS) 
+     <http://web.mit.edu/ist/topics/windows/updates/>
+
+What is MIT Windows Automatic Update Service?
+
+The MIT Windows Automatic Update Service (WAUS) enables the MIT community to 
+utilize Microsoft's "Automatic Update" feature with a more conservative 
+selection of patches -- focused on critical security updates -- than those 
+available directly from Microsoft. This service may be used by MIT faculty, 
+staff, and students on MIT-owned and personal machines.
+
+Should you have any questions or concerns about the operating system 
+upgrade, please contact the Computing Help Desk, <computing-help@mit.edu> 
+Questions, comments or suggestions about the Campus Agreement may be 
+directed to the Software Release Team, <swrt@mit.edu>
+
+Cordially,
+
+Information Services and Technology
Index: trunk/packages/sipb-xen-www/code/templates/list.tmpl
===================================================================
--- trunk/packages/sipb-xen-www/code/templates/list.tmpl	(revision 886)
+++ trunk/packages/sipb-xen-www/code/templates/list.tmpl	(revision 912)
@@ -102,5 +102,9 @@
 #end filter
       </table>
-      <input type="submit" class="button" value="Create it!"/>
+      <input type="submit" class="button" value="Create it!"/><br />
+      Windows notes: #slurp
+#filter None
+$helppopup('Windows')#slurp
+#end filter
     </form>
 #end if