Index: trunk/packages/sipb-xen-base/files/usr/share/python-support/sipb-xen-base/invirt/common.py
===================================================================
--- trunk/packages/sipb-xen-base/files/usr/share/python-support/sipb-xen-base/invirt/common.py	(revision 885)
+++ trunk/packages/sipb-xen-base/files/usr/share/python-support/sipb-xen-base/invirt/common.py	(revision 1197)
@@ -1,4 +1,7 @@
+from __future__ import with_statement
+
 import unittest
 from fcntl import flock, LOCK_EX, LOCK_SH, LOCK_UN
+import contextlib as clib
 
 class struct(object):
@@ -21,44 +24,16 @@
         return x
 
-#
-# Hacks to work around lack of Python 2.5's `with` statement.
-#
-
-def with_closing(rsrc):
-    """
-    Utility to emulate Python 2.5's `with closing(rsrc)` context manager.
-
-    E.g.,
-    @with_closing(file('/tmp/foo'))
-    def contents(f):
-        return f.read()
-    # now 'contents' is the contents of /tmp/foo
-    """
-    def wrapper(func):
-        try: return func(rsrc)
-        finally: rsrc.close()
-    return wrapper
-
-def with_lock_file(path, exclusive = True):
-    """
-    Context manager for lock files.  Example:
-
-    @with_lock_file('/tmp/mylock')
-    def input():
-        print 'locked'
-        return raw_input()
-    # prints 'locked'
-    print input # prints what raw_input() returned
-    """
-    def wrapper(func):
-        @with_closing(file(path, 'w'))
-        def g(f):
-            if exclusive: locktype = LOCK_EX
-            else:         locktype = LOCK_SH
-            flock(f, locktype)
-            try: return func()
-            finally: flock(f, LOCK_UN)
-        return g
-    return wrapper
+@clib.contextmanager
+def lock_file(path, exclusive = True):
+    with clib.closing(file(path, 'w')) as f:
+        if exclusive:
+            locktype = LOCK_EX
+        else:
+            locktype = LOCK_SH
+        flock(f, locktype)
+        try:
+            yield
+        finally:
+            flock(f, LOCK_UN)
 
 #
Index: trunk/packages/sipb-xen-base/files/usr/share/python-support/sipb-xen-base/invirt/config.py
===================================================================
--- trunk/packages/sipb-xen-base/files/usr/share/python-support/sipb-xen-base/invirt/config.py	(revision 885)
+++ trunk/packages/sipb-xen-base/files/usr/share/python-support/sipb-xen-base/invirt/config.py	(revision 1197)
@@ -1,10 +1,13 @@
+from __future__ import with_statement
+
 import json
 from invirt.common import *
 from os import rename
 from os.path import getmtime
+from contextlib import closing
 
 default_src_path   = '/etc/invirt/master.yaml'
 default_cache_path = '/var/lib/invirt/cache.json'
-lock_file          = '/var/lib/invirt/cache.lock'
+lock_path          = '/var/lib/invirt/cache.lock'
 
 def load(src_path = default_src_path,
@@ -54,6 +57,7 @@
         # lock with other concurrent reads).  This isolation is accomplished
         # using an atomic filesystem rename in the refreshing stage.
-        try: ns.cfg = with_closing(file(cache_path)) (
-                lambda f: json.read(f.read()))
+        try: 
+            with closing(file(cache_path)) as f:
+                ns.cfg = json.read(f.read())
         except: do_refresh = True
 
@@ -69,15 +73,15 @@
         except: loader = yaml.SafeLoader
         try:
-            @with_lock_file(lock_file)
-            def refresh_cache():
-                ns.cfg = with_closing(file(src_path)) (
-                        lambda f: yaml.load(f, loader))
-                try: with_closing(file(cache_path + '.tmp', 'w')) (
-                        lambda f: f.write(json.write(ns.cfg)))
+            with lock_file(lock_path):
+                with closing(file(src_path)) as f:
+                    ns.cfg = yaml.load(f, loader)
+                try: 
+                    with closing(file(cache_path + '.tmp', 'w')) as f:
+                        f.write(json.write(ns.cfg))
                 except: pass # silent failure
                 else: rename(cache_path + '.tmp', cache_path)
         except IOError:
-            ns.cfg = with_closing(file(src_path)) (
-                    lambda f: yaml.load(f, loader))
+            with closing(file(src_path)) as f:
+                ns.cfg = yaml.load(f, loader)
     return ns.cfg
 