Index: trunk/packages/sipb-xen-remctl-auto/files/etc/cron.d/sipb-xen-remctl-auto
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/etc/cron.d/sipb-xen-remctl-auto	(revision 1167)
+++ 	(revision )
@@ -1,10 +1,0 @@
-# /etc/cron.d/sipb-xen-remctl-auto: crontab entries for the sipb-xen-remctl-auto package
-
-PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
-MAILTO=root
-UPDATE=/usr/sbin/remctl-update.sh
-
-@reboot         root    if [ -x "$UPDATE" ]; then nice -n10 "$UPDATE" all; fi
-* * * * */15       root    if [ -x "$UPDATE" ]; then nice -n10 "$UPDATE" all; fi
-
-# EOF
Index: trunk/packages/sipb-xen-remctl-auto/files/etc/remctl/acl/remote.mako
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/etc/remctl/acl/remote.mako	(revision 1167)
+++ 	(revision )
@@ -1,2 +1,0 @@
-<% from invirt.config import structs as cfg %>\
-host/${cfg.remote.hostname}@${cfg.authn[0].realm}
Index: trunk/packages/sipb-xen-remctl-auto/files/etc/remctl/conf.d/sipb-xen-remote
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/etc/remctl/conf.d/sipb-xen-remote	(revision 1167)
+++ 	(revision )
@@ -1,2 +1,0 @@
-remote web     /usr/sbin/sipb-xen-remote /etc/remctl/acl/remote
-remote control /usr/sbin/sipb-xen-remote /etc/remctl/acl/remote
Index: trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-boot
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-boot	(revision 1167)
+++ 	(revision )
@@ -1,9 +1,0 @@
-#!/bin/sh
-machine="$2"
-cdrom="$3"
-
-if [ -n "$cdrom" ]; then
-        xm create sipb-database machine_name="$machine" cdrom_image="$cdrom"
-else
-        xm create sipb-database machine_name="$machine"
-fi
Index: trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-listvms
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-listvms	(revision 1167)
+++ 	(revision )
@@ -1,49 +1,0 @@
-#!/usr/bin/python
-
-import sys
-import time
-sys.path.insert(0, '/usr/lib/xen-3.1-1/lib/python')
-from xen.lowlevel import xs
-
-xsc = xs.xs()
-
-def live_vms():
-    domids = set(xsc.ls('', '/local/domain'))
-    domids.discard('0')
-
-    vms = dict()
-
-    for domid in domids:
-        try:
-            name, data = get_dom(int(domid))
-        except (xs.Error, TypeError):
-            continue # went down since we started
-        if name.startswith('d_'):
-            name = name[2:]
-            vms[name] = data
-    return vms
-
-def get_dom(domid):
-    name = xsc.read('', '/local/domain/%d/name' % domid)
-    data = dict()
-    data['domid'] = domid
-    # presence of a graphical console
-    data['console'] = xsc.read('', '/local/domain/%d/device/vfb/0/state' % domid)
-    # uptime
-    data['vm'] = xsc.read('', '/local/domain/%d/vm' % domid)
-    data['start_time'] = float(xsc.read('', '%s/start_time' % data['vm']))
-    data['uptime'] = time.time()-data['start_time']
-    
-    return name, data
-
-if __name__ == '__main__':
-    vms = live_vms()
-    if '--json' in sys.argv[1:]:
-        import cjson
-        print cjson.encode(vms)
-    elif '--pickle' in sys.argv[1:]:
-        import cPickle
-        cPickle.dump(vms, sys.stdout, cPickle.HIGHEST_PROTOCOL)
-    else:
-        import yaml
-        print yaml.dump(vms, Dumper=yaml.CSafeDumper, default_flow_style=False)
Index: trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-lvm
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-lvm	(revision 1167)
+++ 	(revision )
@@ -1,85 +1,0 @@
-#!/usr/bin/env python
-
-import sys
-import os.path
-from subprocess import call, PIPE, Popen
-from invirt.config import structs as config
-
-def check(b):
-    if not b:
-        exit(1)
-
-vg = "xenvg"
-prefix = "d_"
-
-subcommand = sys.argv[1]
-
-def ensureoff(machine):
-    # Make sure the machine is off, but we don't care about errors if it is already off.
-    rv = call(["/usr/sbin/xm", "destroy", prefix + machine],
-              stderr=PIPE)
-
-if subcommand == "lvcreate-all":
-    from invirt import database
-    import re
-    database.connect()
-    for d in Disk.select():
-        check(re.match('^[A-Za-z0-9]+$', d.guest_device_name))
-        machine = Machine.get(d.machine_id)
-        check(re.match('^[A-Za-z0-9][A-Za-z0-9._-]*$', machine.name))
-        lvname = prefix + machine.name + "_" + d.guest_device_name
-        if not os.path.exists("/dev/%s/%s" % (vg, lvname)):
-            # LV doesn't exist
-            print >>sys.stderr, "Creating LV %s..." % (lvname,)
-            rv = call(["/sbin/lvcreate", "-L", str(d.size) + "M", "-n", lvname, vg])
-            if rv != 0:
-                print >>sys.stderr, "Error creating LV %s\n" %(lvname,)
-                sys.exit(1)
-else:
-    machine = sys.argv[2]
-    disk = sys.argv[3]
-    lvname = prefix + machine + "_" + disk
-    lvpath = "/dev/" + vg + "/" + lvname
-if subcommand == "lvremove":
-    def error():
-        print >>sys.stderr, "Error removing LV %s\n" % lvname
-        sys.exit(1)
-    rv = call(["/sbin/lvchange", "-a", "n", lvpath])
-    if rv != 0:
-        error()
-    rv = call(["/sbin/lvchange", "-a", "ey", lvpath])
-    if rv != 0:
-        error()
-    rv = call(["/sbin/lvremove", "--force", lvpath])
-    if rv != 0:
-        error()
-    ensureoff(machine)
-elif subcommand == "lvresize":
-    size = sys.argv[4]
-    ensureoff(machine)
-    p = Popen(["/sbin/lvresize", "-L", size + "M", lvpath],
-              stdin=PIPE, stderr=PIPE)
-    print >> p.stdin, 'y'
-    err = p.stderr.read()
-    if p.wait() != 0 and 'matches existing size' not in err:
-        print >> sys.stderr, "Error resizing LV %s:\n" %(lvname,)
-        print >> sys.stderr, err
-        sys.exit(1)
-    print >> sys.stderr, err
-elif subcommand == "lvrename":
-    newmachine = sys.argv[4]
-    newlvname = prefix + newmachine + "_" + disk
-    ensureoff(machine)
-    ensureoff(newmachine)    
-    rv = call(["/sbin/lvrename", vg, lvname, newlvname])
-    if rv != 0:
-        print >>sys.stderr, "Error renaming LV %s\n" %(lvname,)
-        sys.exit(1)
-elif subcommand == "lvcreate":
-    size = sys.argv[4]
-    rv = call(["/sbin/lvcreate", "-L", size + "M", "-n", lvname, vg])
-    if rv != 0:
-        print >>sys.stderr, "Error creating LV %s\n" %(lvname,)
-        sys.exit(1)
-    
-
Index: trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-remote
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-remote	(revision 1167)
+++ 	(revision )
@@ -1,42 +1,0 @@
-#!/bin/sh
-# sipb-xen-remote TYPE SERVICE [ARGS...]
-#
-# We carry out the remctl command proxied to us by the remote-control server.
-
-TYPE="$1"
-SERVICE="$2"
-shift; shift;
-
-case "$TYPE" in
-    control)
-        # $SERVICE is hostname
-        COMMAND=/usr/sbin/sipb-xen-vmcontrol
-	;;
-    web)
-        case "$SERVICE" in
-            lvcreate|lvremove|lvrename|lvresize)
-                COMMAND=/usr/sbin/sipb-xen-lvm
-	        ;;
-            vmboot)
-                COMMAND=/usr/sbin/sipb-xen-vmcontrol
-	        ;;
-            listvms)
-                COMMAND=/usr/sbin/sipb-xen-listvms
-	        ;;
-	    info)
-		COMMAND=/usr/sbin/xm
-		;;
-            *)
-                echo "ERROR: invalid subcommand"
-                exit 34
-                ;;
-        esac
-	;;
-    *)
-        echo "ERROR: invalid command"
-        exit 34
-        ;;
-esac
-
-#echo $COMMAND "$SERVICE" "$@"
-$COMMAND "$SERVICE" "$@"
Index: trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-vmcontrol
===================================================================
--- trunk/packages/sipb-xen-remctl-auto/files/usr/sbin/sipb-xen-vmcontrol	(revision 1167)
+++ 	(revision )
@@ -1,47 +1,0 @@
-#!/bin/bash
-# sipb-xen-vmcontrol MACHINE ACTION
-#
-# remctl should have already verified that the user is authorized to
-# control the machine.  So, we just need to execute the action requested.
-#
-# $0 and $1 come from the trusted remctl source.
-#
-# $2 and so on are user-provided, and thus sketchy.  I don't think we
-# need them for this script.
-
-ORIGMACHINE="$1"
-ACTION="$2"
-MACHINE="d_$ORIGMACHINE"
-
-case "$ACTION" in
-    list|vcpu-list|uptime)
-        xm "$ACTION" "$MACHINE"
-	;;
-    destroy|shutdown)
-	xm "$ACTION" "$MACHINE"
-	/usr/sbin/sipb-xen-update-conserver </dev/null >/dev/null 2>&1 &
-	;;
-    install|create|reboot)
-	shift; shift;
-	if [ "$ACTION" = "reboot" ]; then
-	    xm destroy "$MACHINE" 2>/dev/null
-	else
-	    xm list "$MACHINE" >/dev/null 2>/dev/null && echo "$MACHINE already exists" && exit 1
-	fi
-	if [ "$ACTION" = "install" ]; then
-	    xm create sipb-database machine_name="$ORIGMACHINE" installer_options="$(printf '%q ' "$@")"
-	elif [ -n "$1" ]; then
-	    xm create sipb-database machine_name="$ORIGMACHINE" cdrom_image="$1"
-	else
-	    xm create sipb-database machine_name="$ORIGMACHINE"
-	fi
-	(sleep 4; /usr/sbin/sipb-xen-update-conserver) </dev/null >/dev/null 2>&1 &
-	;;
-    list-long)
-	xm list --long "$MACHINE"
-	;;
-    *)
-        echo "ERROR: Invalid Command"
-        exit 34
-        ;;
-esac